package com.canaan.share.cache;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.date.LocalDateTimeUtil;
import com.canaan.share.common.constant.BaseRedisConstant;
import com.canaan.share.common.entities.mysql.base.*;
import com.canaan.share.exceptions.BusinessException;
import com.canaan.share.model.cache.*;
import com.canaan.share.repositories.mysql.base.*;
import com.canaan.share.utils.RedisUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 缓存基础数据
 */
@Component
@Slf4j
public class BaseCommonCache {

    public static final String ALL = "ALL";
    // 5分钟
    private static long SAVE_TIME = 60 * 5;

    @Resource
    private RedisUtils redisUtils;
    @Resource
    private FarmInfoTableRepository farmInfoTableRepository;

	//PS ：缓存数据对象一定要重新自定义，不要和其他业务对象重复，否则业务对象进行修改会影响缓存数据
    
    /**
     * 通过farmCode获取矿场信息, 如果缓存中没有, 则从数据库中查询并缓存
     * @param key
     * @return 缓存数据对象
     */
    public XXXXX getFarm(String farmCode) {
        String key = BaseRedisConstant.BASE_FARM_INFO_CACHE + farmCode;
        XXXXX XXXXX = (XXXXX) redisUtils.get(key);
        if (Objects.isNull(XXXXX) || StringUtils.isBlank(XXXXX.getFarmCode())) {
            XXXXX = this.getFarmInfoFromDB(farmCode);
            redisUtils.set(key, XXXXX);
        }
        return XXXXX;
    }

    /**
     * 通过farmCode删除矿场缓存
     * @param farmCode
     */
    public void deleteFarm(String farmCode) {
        String key = BaseRedisConstant.BASE_FARM_INFO_CACHE + farmCode;
        redisUtils.del(key);
    }

    /**
     * 重新缓存矿场信息
     * @param farmCode
     */
    public XXXXX reCacheFarm(String farmCode) {
        String key = BaseRedisConstant.BASE_FARM_INFO_CACHE + farmCode;
        XXXXX XXXXX = this.getFarmInfoFromDB(farmCode);
        redisUtils.set(key, XXXXX);
        return XXXXX;
    }


}
